!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! mod_poisson.f90  --- Module principal
!!
!! Auteur : Philippe WAUTELET (CNRS/IDRIS - France)
!!          <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_poisson
  use MPI

  !Parameters
  INTEGER, PARAMETER                        :: ndims = 3
  !Nombre iterations maximum en temps
  INTEGER, PARAMETER                        :: it_max = 100
  !Frequence affichage
  INTEGER, PARAMETER                        :: freq_affichage = it_max/10
  !Taille du probleme (nb de points par direction)
  INTEGER, PARAMETER                        :: taille_probleme = 2048

  !Nombre iterations en temps
  INTEGER                                   :: it
  !Solution u et u_nouveau a l'iteration n et n+1
  REAL(kind=8), DIMENSION(:,:,:), ALLOCATABLE :: u, u_nouveau
  !Solution exacte
  REAL(kind=8), DIMENSION(:,:,:), ALLOCATABLE :: u_exact
  !Second membre
  REAL(kind=8), DIMENSION(:,:,:), ALLOCATABLE :: f
  !Nombre total de points interieurs suivant x, y et z
  INTEGER                                   :: ntx, nty, ntz
  !Borne inferieure et superieure en x
  INTEGER                                   :: sx, ex
  !Borne inferieure et superieure en y
  INTEGER                                   :: sy, ey
  !Borne inferieure et superieure en y
  INTEGER                                   :: sz, ez
  !Pas
  REAL(kind=8)                              :: h
  !Numero du sous domaine
  INTEGER                                   :: rang
  INTEGER                                   :: rang_ds_topo
  INTEGER, DIMENSION(ndims)                 :: coords
  !Nombre de processus
  INTEGER                                   :: nb_procs
  !Tableau contenant les voisins du sous domaine courant
  INTEGER, PARAMETER                        :: NB_VOISINS = 6
  INTEGER, DIMENSION(NB_VOISINS)            :: voisin
  INTEGER, PARAMETER                        :: N=1, E=2, S=3, W=4, AR=5, AV=6
  !Constantes MPI
  INTEGER                                   :: comm3d,code
  INTEGER, DIMENSION(ndims)                 :: dims
end module mod_poisson
