!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! voisinage.f90  --- Calcul pour chaque processus de ses 6 processus voisins.
!!
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France)
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_vois
  contains
!*******************************************************************
SUBROUTINE voisinage()
  !*******************************************************************

  USE mod_poisson

  IMPLICIT NONE

  !Initialisation du tableau voisin
  voisin(:) = MPI_PROC_NULL

  !Recherche des voisins Ouest et Est
  CALL MPI_CART_SHIFT( comm3d, 0, 1, voisin(W), voisin(E), code)
  !Recherche des voisins Nord et Sud
  CALL MPI_CART_SHIFT( comm3d, 1, 1, voisin(S), voisin(N), code)
  !Recherche des voisins Avant et Arriere
  CALL MPI_CART_SHIFT( comm3d, 2, 1, voisin(AV), voisin(AR), code)

END SUBROUTINE voisinage
end module mod_vois
