Program  map1
   use mpi
   implicit none 

   integer                                   :: myrank, size, ierr, tag, status(MPI_STATUS_SIZE)
   integer, parameter                        :: N=1000000
   integer                                   :: source
   real(kind=8), allocatable, dimension(:,:) :: var
   real(kind=8)                              :: t1, t2, etime, nbytes, bandwidth


   call MPI_INIT(ierr)

   allocate(var(1000,1000))
   
   call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)
   call MPI_COMM_RANK(MPI_COMM_WORLD, myrank, ierr)
   var = myrank
   t1 = MPI_WTIME()
 
   if ( mod(myrank,4) .eq. 0) then
     call  MPI_SEND(var, N, MPI_DOUBLE_PRECISION, myrank+1, myrank+1, MPI_COMM_WORLD, ierr)  
     call  MPI_SEND(var, N, MPI_DOUBLE_PRECISION, myrank+2, myrank+2, MPI_COMM_WORLD, ierr)
     call  MPI_SEND(var, N, MPI_DOUBLE_PRECISION, myrank+3, myrank+3, MPI_COMM_WORLD, ierr)
     call  MPI_RECV(var, N, MPI_DOUBLE_PRECISION, myrank+1, myrank, MPI_COMM_WORLD, status, ierr)
     call  MPI_RECV(var, N, MPI_DOUBLE_PRECISION, myrank+2, myrank, MPI_COMM_WORLD, status, ierr)
     call  MPI_RECV(var, N, MPI_DOUBLE_PRECISION, myrank+3, myrank, MPI_COMM_WORLD, status, ierr)   
   else  
     source = myrank - mod(myrank,4)
     call MPI_RECV(var, N, MPI_DOUBLE_PRECISION, source, myrank, MPI_COMM_WORLD, status, ierr)
     call MPI_SEND(var, N, MPI_DOUBLE_PRECISION, source, source, MPI_COMM_WORLD, ierr) 
   end if
   
   t2 = MPI_WTIME()
   etime = t2-t1
   nbytes = 6*N*8
   bandwidth = (1.0 * nbytes)/(etime*1000000)

   if (mod(myrank,4) .eq. 0) then  
     print *,"Rank = ",Myrank," Bandwidth (MB/s) =",bandwidth  
   end if 


   call MPI_FINALIZE(ierr)
end
