Program map2
   use mpi
   implicit none 

   integer                                   :: myrank, size, ierr, tag, status(MPI_STATUS_SIZE)
   integer, parameter                        :: N=1000000
   integer                                   :: source
   real(kind=8), allocatable, dimension(:,:) :: var
   real(kind=8)                              :: t1, t2, etime, nbytes, bandwidth, minband, maxband 


   call MPI_INIT(ierr)

   allocate(var(1000,1000))
   
   call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)
   call MPI_COMM_RANK(MPI_COMM_WORLD, myrank, ierr)
   if ( size .ne. 16 ) then
   print*, 'For this Test the Number of Procs is fixed to 16'
   call MPI_ABORT(MPI_COMM_WORLD, ierr)
   end if 

   var = myrank
   t1 = MPI_WTIME()
 
   if ( myrank < 8 ) then
     call  MPI_SEND(var, N, MPI_DOUBLE_PRECISION, myrank+8, myrank+8, MPI_COMM_WORLD, ierr)  
     call  MPI_RECV(var, N, MPI_DOUBLE_PRECISION, myrank+8, myrank, MPI_COMM_WORLD, status, ierr)   
   else  
     source = myrank - 8
     call MPI_RECV(var, N, MPI_DOUBLE_PRECISION, source, myrank, MPI_COMM_WORLD, status, ierr)
     call MPI_SEND(var, N, MPI_DOUBLE_PRECISION, source, source, MPI_COMM_WORLD, ierr) 
   end if
   
   t2 = MPI_WTIME()
   
   etime = t2-t1
   nbytes = 2*N*8
   bandwidth = (1.0 * nbytes)/(etime*1000000)
   call MPI_REDUCE(bandwidth, minband, 1, MPI_DOUBLE_PRECISION, MPI_MIN, 0, MPI_COMM_WORLD, ierr)
   call MPI_REDUCE(bandwidth, maxband, 1, MPI_DOUBLE_PRECISION, MPI_MAX, 0, MPI_COMM_WORLD, ierr)

   if (myrank .eq. 0) then
     print *," Bandwidth (MB/s): min=",minband," max=",maxband
   end if
  

   call MPI_FINALIZE(ierr)
end
