!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! domaine.f90  --- Calcul du nombre de points dans chaque sous-domaine suivant
!!                 x, y et z en fonction du nombre total de points suivant x, y
!!                 et z.
!!
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France)
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_dom
  contains

!**********************************************************
SUBROUTINE domaine()
  !**********************************************************

  use mod_poisson
  use mod_equil
  IMPLICIT NONE

  !**********************************************************

  !Connaitre mes coordonnees dans la topologie
  CALL MPI_COMM_RANK(comm3d, rang_ds_topo, code)
  CALL MPI_CART_COORDS(comm3d, rang_ds_topo, ndims, coords, code)

  !Calcul des indices des points suivant x dans chaque domaine
  CALL equilibrage(ntx, dims(1), coords(1), sx, ex)

  !Calcul des indices des points suivant y dans chaque domaine
  CALL equilibrage(nty, dims(2), coords(2),sy, ey)

  !Calcul des indices des points suivant z dans chaque domaine
  CALL equilibrage(ntz, dims(3), coords(3),sz, ez)

END SUBROUTINE domaine
end module mod_dom