!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! erreur.f90  --- Calcul de l'erreur dans un sous-domaine.
!!                 Maximum de la valeur absolue de la difference de u a
!!                 l'iteration n et de u a l'iteration n+1.
!! 
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France) 
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_erreur
  contains
!*******************************************************************
REAL(kind=8) FUNCTION erreur ()
  !*****************************************************************

  USE mod_poisson

  IMPLICIT NONE

  integer :: i,j,k

  !Calcul de l'erreur
  !erreur = MAXVAL (ABS(u(sx:ex,sy:ey,sz:ez)-u_nouveau(sx:ex,sy:ey,sz:ez)))

  erreur = -1.d0
  do i = sx,ex
    do j = sy,ey
      do k = sz,ez
        if (ABS(u(i,j,k)-u_nouveau(i,j,k)) > erreur) then
          erreur = ABS(u(i,j,k)-u_nouveau(i,j,k))
        end if
      end do
    end do
  end do
END FUNCTION erreur
end module mod_erreur