!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! erreur.f90  --- Calcul de l'erreur dans un sous-domaine.
!!                 Maximum de la valeur absolue de la difference de u a
!!                 l'iteration n et de u a l'iteration n+1.
!! 
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France) 
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_erreur
  contains
!*******************************************************************
REAL(kind=8) FUNCTION erreur ()
  !*****************************************************************

  USE mod_poisson

  IMPLICIT NONE

  !Compteurs
  INTEGER                               :: i,j,k
  real(kind=8)                          :: errloc

  errloc = -1.d0
  !Calcul de l'erreur
  !$OMP PARALLEL DO REDUCTION(MAX:errloc) SCHEDULE(STATIC)
  do k = sz,ez
    do j = sy,ey
      do i = sx,ex
        errloc = MAX(errloc,ABS(u(i,j,k)-u_nouveau(i,j,k)))
      end do
    end do
  end do
  !$OMP END PARALLEL DO

  erreur=errloc
END FUNCTION erreur
end module mod_erreur