# @ job_name = poisson
# @ job_type = BLUEGENE
# Fichier sortie standard du travail
# @ output = $(job_name).$(jobid)
# Fichier erreur standard du travail
# @ error = $(output)
# Temps elapsed maximum demande
# @ wall_clock_limit = 1:00:00
# Taille partition d'execution
# @ bg_size = 64
# @ queue

set -x

runjob --ranks-per-node 1 --np 64 : ./poisson.mpi
runjob --ranks-per-node 2 --np 128 : ./poisson.mpi
runjob --ranks-per-node 4 --np 256 : ./poisson.mpi
runjob --ranks-per-node 8 --np 512 : ./poisson.mpi
runjob --ranks-per-node 16 --np 1024 : ./poisson.mpi
runjob --ranks-per-node 32 --np 2048 : ./poisson.mpi
runjob --ranks-per-node 64 --np 4096 : ./poisson.mpi

runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=1" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=2" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=4" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=8" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=16" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=32" --np 64 : ./poisson.mpiomp
runjob --ranks-per-node 1 --envs "OMP_NUM_THREADS=64" --np 64 : ./poisson.mpiomp

runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=1" --np 128 : ./poisson.mpiomp
runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=2" --np 128 : ./poisson.mpiomp
runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=4" --np 128 : ./poisson.mpiomp
runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=8" --np 128 : ./poisson.mpiomp
runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=16" --np 128 : ./poisson.mpiomp
runjob --ranks-per-node 2 --envs "OMP_NUM_THREADS=32" --np 128 : ./poisson.mpiomp

runjob --ranks-per-node 4 --envs "OMP_NUM_THREADS=1" --np 256 : ./poisson.mpiomp
runjob --ranks-per-node 4 --envs "OMP_NUM_THREADS=2" --np 256 : ./poisson.mpiomp
runjob --ranks-per-node 4 --envs "OMP_NUM_THREADS=4" --np 256 : ./poisson.mpiomp
runjob --ranks-per-node 4 --envs "OMP_NUM_THREADS=8" --np 256 : ./poisson.mpiomp
runjob --ranks-per-node 4 --envs "OMP_NUM_THREADS=16" --np 256 : ./poisson.mpiomp

runjob --ranks-per-node 8 --envs "OMP_NUM_THREADS=1" --np 512 : ./poisson.mpiomp
runjob --ranks-per-node 8 --envs "OMP_NUM_THREADS=2" --np 512 : ./poisson.mpiomp
runjob --ranks-per-node 8 --envs "OMP_NUM_THREADS=4" --np 512 : ./poisson.mpiomp
runjob --ranks-per-node 8 --envs "OMP_NUM_THREADS=8" --np 512 : ./poisson.mpiomp

runjob --ranks-per-node 16 --envs "OMP_NUM_THREADS=1" --np 1024 : ./poisson.mpiomp
runjob --ranks-per-node 16 --envs "OMP_NUM_THREADS=2" --np 1024 : ./poisson.mpiomp
runjob --ranks-per-node 16 --envs "OMP_NUM_THREADS=4" --np 1024 : ./poisson.mpiomp

runjob --ranks-per-node 32 --envs "OMP_NUM_THREADS=1" --np 2048 : ./poisson.mpiomp
runjob --ranks-per-node 32 --envs "OMP_NUM_THREADS=2" --np 2048 : ./poisson.mpiomp

runjob --ranks-per-node 64 --envs "OMP_NUM_THREADS=1" --np 4096 : ./poisson.mpiomp
