!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! communication.f90  --- Communication des valeurs aux interfaces pour
!!                        la solution u a l'iteration n.
!! 
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France) 
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_comm
contains

!*******************************************************************
SUBROUTINE communication( plan_xy, plan_yz, plan_xz )

  !*******************************************************************

  USE mod_poisson

  IMPLICIT NONE
  !--Declaration des variables

  INTEGER                              :: plan_xy, plan_yz, plan_xz
  !Constantes MPI
  INTEGER, PARAMETER                   :: etiquette=100
  INTEGER, DIMENSION(MPI_STATUS_SIZE)  :: statut

  !*******************************************************************

  !Envoi au voisin N et reception du voisin S 
  CALL MPI_SENDRECV( u(sx,ey,sz), 1, plan_xz, voisin(N), &
       etiquette,  u(sx,sy-1,sz), 1, plan_xz, voisin(S), &
       etiquette, comm3d, statut, code)

  !Envoi au voisin S et reception du voisin N
  CALL MPI_SENDRECV( u(sx,sy,sz), 1, plan_xz, voisin(S), &
       etiquette,  u(sx,ey+1,sz), 1, plan_xz, voisin(N), &
       etiquette, comm3d, statut,code)

  !Envoi au voisin W et reception du voisin E
  CALL MPI_SENDRECV( u(sx,sy,sz), 1, plan_yz, voisin(W), &
       etiquette,  u(ex+1,sy,sz), 1, plan_yz, voisin(E), &
       etiquette, comm3d, statut, code)

  !Envoi au voisin E et reception du voisin W
  CALL MPI_SENDRECV( u(ex,sy,sz), 1, plan_yz, voisin(E), &
       etiquette,  u(sx-1,sy,sz), 1, plan_yz, voisin(W), &
       etiquette, comm3d, statut, code)

  !Envoi au voisin AV et reception du voisin AR
  CALL MPI_SENDRECV( u(sx,sy,sz), 1, plan_xy, voisin(AV), &
       etiquette,  u(sx,sy,ez+1), 1, plan_xy, voisin(AR), &
       etiquette, comm3d, statut, code)

  !Envoi au voisin AR et reception du voisin AV
  CALL MPI_SENDRECV( u(sx,sy,ez), 1, plan_xy, voisin(AR), &
       etiquette,  u(sx,sy,sz-1), 1, plan_xy, voisin(AV), &
       etiquette, comm3d, statut, code)

END SUBROUTINE communication
end module mod_comm
