!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! equilibrage.f90  --- Reequilibrage dans chaque sous-domaine du nombre
!!                      de points.
!!
!! Auteur          : Isabelle DUPAYS (CNRS/IDRIS - France)
!!                   <Isabelle.Dupays@idris.fr>
!! Cree le         : Fri Nov 15 10:32:45 1996
!! Modifie par     : Philippe WAUTELET (CNRS/IDRIS - France)
!!                   <Philippe.Wautelet@idris.fr>
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module mod_equil
  contains
!**********************************************************
SUBROUTINE equilibrage ( n, mon_numproc, mon_rang, deb, fin)
  !**********************************************************

  IMPLICIT NONE

  !--Declaration des variables

  !Nombre total de points
  INTEGER :: n
  !Indice de debut et de fin
  INTEGER :: deb,fin
  !Nombre de sous domaines suivant une direction
  INTEGER :: mon_numproc
  !Coordonnees suivant une direction
  INTEGER :: mon_rang
  !Nombre de points pour un sous-domaine
  INTEGER :: nlocal
  !Deficit en points
  INTEGER :: deficit

  !**********************************************************

  !Calcul du nombre de points dans chaque sous domaine
  nlocal  = n / mon_numproc

  !Calcul de la borne inferieure
  deb     = mon_rang * nlocal + 1
  deficit = MOD(n, mon_numproc)
  deb     = deb + MIN( mon_rang, deficit)

  !Reequilibrage des points dans les sous domaines
  IF ( mon_rang < deficit ) THEN
     nlocal = nlocal + 1
  END IF

  !Calcul de la borne superieure
  fin = deb + nlocal - 1

  !Calcul de la borne superieure pour le dernier sous domaine
  IF ((fin >  n) .or. ( mon_rang ==  mon_numproc-1)) fin=n

END SUBROUTINE equilibrage
end module mod_equil